#include "circle.hpp"

#include "shape_visitor.hpp"

namespace shapes {

	// In der Initialisierungsliste im Konstruktor müssen wir zuerst den Konstruktor der Basisklasse aufrufen.
	Circle::Circle(float x, float y, Color color, float radius)
	  : Shape(x, y, color), radius_(radius) {}

	// Bei der Implementierung außerhalb der Klasse dürfen wir weder virtual, override noch final angeben!
	float Circle::area() const {
		return radius_ * radius_ * 3.14159f;
	}
	float Circle::circumference() const {
		return 2.f * radius_ * 3.14159f;
	}
	
	void Circle::visit(Shape_visitor& visitor) const {
		// Ruft die Überladung der visit-Methode in Shape_visitor für Circle auf.
		visitor.visit(*this);
	}

} // namespace shapes
