#pragma once

#include "shape.hpp"

namespace shapes {

	// Wir erben (public) von Shape, übernehmen also alle Member Funktionen/Variablen und müssen
	//   alle pure virtual Funktionen implementieren.
	// Außerdem markieren wir unsere Klasse als final, damit man nicht weiter von ihr ableiten kann
	class Circle final : public Shape {
	  public:
		Circle(float x, float y, Color color, float radius);
		
		// Wir überschreiben die Methoden in der Basisklasse.
		// Das virtual ist beim Überschreiben optional und können wir hier guten gewissens auslassen,
		//    da override bereits erzwingt das wir auch tatsächlich überschreiben statt überladen/verdecken.
		float area() const override;
		float circumference() const override;
		
		float radius()const {return radius_;}

		void visit(Shape_visitor&) const override;

	  private:
		float radius_;
	};

} // namespace shapes
