#include "rectangle.hpp"

#include "shape_visitor.hpp"

namespace shapes {

	// In der Initialisierungsliste im Konstruktor müssen wir zuerst den Konstruktor der Basisklasse aufrufen.
	Rectangle::Rectangle(float x, float y, Color color, float width, float height)
	  : Shape(x, y, color), width_(width), height_(height) {}

	// Bei der Implementierung außerhalb der Klasse dürfen wir weder virtual, override noch final angeben!
	float Rectangle::area() const {
		return width_ * height_;
	}
	float Rectangle::circumference() const {
		return 2.f*width_ + 2.f*height_;
	}
	
	void Rectangle::visit(Shape_visitor& visitor) const {
		// Ruft die Überladung der visit-Methode in Shape_visitor für Circle auf.
		visitor.visit(*this);
	}

} // namespace shapes
