#pragma once

#include "shape.hpp"

namespace shapes {

	// Wir erben (public) von Shape, übernehmen also alle Member Funktionen/Variablen und müssen
	//   alle pure virtual Funktionen implementieren.
	// Außerdem markieren wir unsere Klasse als final, damit man nicht weiter von ihr ableiten kann
	class Rectangle final : public Shape {
	  public:
		Rectangle(float x, float y, Color color, float width, float height);

		// Wir überschreiben die Methoden in der Basisklasse.
		// Das virtual ist beim Überschreiben optional und können wir hier guten gewissens auslassen,
		//    da override bereits erzwingt das wir auch tatsächlich überschreiben statt überladen/verdecken.
		float area() const override;
		float circumference() const override;
		
		float width()const {return width_;}
		float height()const {return height_;}

		void visit(Shape_visitor&) const override;

	  private:
		float width_, height_;
	};

} // namespace shapes
